//
// Copyright (C) 2006, NinjaTrader LLC <ninjatrader@ninjatrader.com>.
// NinjaTrader reserves the right to modify or overwrite this NinjaScript component with each release.
//

#region Using declarations
using System;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private sbLinesAndAlerts[] cachesbLinesAndAlerts = null;

        private static sbLinesAndAlerts checksbLinesAndAlerts = new sbLinesAndAlerts();

        /// <summary>
        /// Lines and alerts indicator by Anton Bazhenov\nhttp://protradestudio.ru
        /// </summary>
        /// <returns></returns>
        public sbLinesAndAlerts sbLinesAndAlerts()
        {
            return sbLinesAndAlerts(Input);
        }

        /// <summary>
        /// Lines and alerts indicator by Anton Bazhenov\nhttp://protradestudio.ru
        /// </summary>
        /// <returns></returns>
        public sbLinesAndAlerts sbLinesAndAlerts(Data.IDataSeries input)
        {
            if (cachesbLinesAndAlerts != null)
                for (int idx = 0; idx < cachesbLinesAndAlerts.Length; idx++)
                    if (cachesbLinesAndAlerts[idx].EqualsInput(input))
                        return cachesbLinesAndAlerts[idx];

            lock (checksbLinesAndAlerts)
            {
                if (cachesbLinesAndAlerts != null)
                    for (int idx = 0; idx < cachesbLinesAndAlerts.Length; idx++)
                        if (cachesbLinesAndAlerts[idx].EqualsInput(input))
                            return cachesbLinesAndAlerts[idx];

                sbLinesAndAlerts indicator = new sbLinesAndAlerts();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                Indicators.Add(indicator);
                indicator.SetUp();

                sbLinesAndAlerts[] tmp = new sbLinesAndAlerts[cachesbLinesAndAlerts == null ? 1 : cachesbLinesAndAlerts.Length + 1];
                if (cachesbLinesAndAlerts != null)
                    cachesbLinesAndAlerts.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cachesbLinesAndAlerts = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// Lines and alerts indicator by Anton Bazhenov\nhttp://protradestudio.ru
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.sbLinesAndAlerts sbLinesAndAlerts()
        {
            return _indicator.sbLinesAndAlerts(Input);
        }

        /// <summary>
        /// Lines and alerts indicator by Anton Bazhenov\nhttp://protradestudio.ru
        /// </summary>
        /// <returns></returns>
        public Indicator.sbLinesAndAlerts sbLinesAndAlerts(Data.IDataSeries input)
        {
            return _indicator.sbLinesAndAlerts(input);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// Lines and alerts indicator by Anton Bazhenov\nhttp://protradestudio.ru
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.sbLinesAndAlerts sbLinesAndAlerts()
        {
            return _indicator.sbLinesAndAlerts(Input);
        }

        /// <summary>
        /// Lines and alerts indicator by Anton Bazhenov\nhttp://protradestudio.ru
        /// </summary>
        /// <returns></returns>
        public Indicator.sbLinesAndAlerts sbLinesAndAlerts(Data.IDataSeries input)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.sbLinesAndAlerts(input);
        }
    }
}
#endregion
